NB. hokusai form 
HOKUSAI=: 0 : 0
pc hokusai;
xywh 7 12 139 19;cc selek groupbox;cn "Komon name";
xywh 56 19 34 11;cc rb4 radiobutton ;cn "漢字";
xywh 90 17 44 13;cc rb5 radiobutton group;cn "English";
xywh 6 39 139 46;cc type groupbox;cn "pattern";
xywh 18 51 35 13;cc rb0 radiobutton;cn "Polygon";
xywh 85 54 51 13;cc rb1 radiobutton group;cn "Straight lines";
xywh 18 70 49 12;cc rb2 radiobutton group;cn "Geometric";
xywh 83 71 54 11;cc rb3 radiobutton group;cn "Bezier curves";
xywh 162 19 42 67;cc seltype button;cn "Select Type";
xywh 5 87 143 78;cc komon combobox rightmove;
xywh 160 107 48 34;cc komontype button;cn "Komon/Color";
xywh 5 184 24 11;cc ColorR static;cn "Red";
xywh 3 201 22 11;cc ColorG static;cn "Green";
xywh 4 220 23 11;cc ColorB static;cn "Blue";
xywh 27 168 32 12;cc Color0 static;cn "Color-0";
xywh 68 168 32 11;cc Color1 static;cn "Color-1";
xywh 107 168 42 12;cc Color2 static;cn "Color-2";
xywh 28 181 30 12;cc Color0R edit;
xywh 28 200 30 12;cc Color0G edit;
xywh 29 218 30 12;cc Color0B edit;
xywh 66 181 33 12;cc Color1R edit;
xywh 68 201 32 12;cc Color1G edit;
xywh 67 220 32 12;cc Color1B edit;
xywh 105 182 40 12;cc Color2R edit;
xywh 107 202 38 12;cc Color2G edit;
xywh 107 221 39 12;cc Color2B edit;
xywh 159 205 44 45;cc ok button;cn " DRAW";
xywh 6 238 52 11;cc sizekomon static;cn "Size(komon raw)";
xywh 67 240 60 60;cc size combodrop;
pas 6 6;pcenter;
rem form end;
)

NB. =====================================
NB. ----(1)--initial---------
hokusai_run=: 3 : 0
wd HOKUSAI
NB. initialize form here
set_size ''
wd 'pshow;'
)

hokusai_close=: 3 : 0
wd'pclose'
)


NB. ======================================
NB. ------------------set size------------------
set_size=: 3 : 0
wd 'set size "2" "5" "7" "10" "12" "15" "20" "25" '
wd 'setselect size 2'
)

NB. ================================================
NB. --(2) seltype_button------------------------
hokusai_seltype_button=: 3 : 0
SEL=. ". rb0,rb1,rb2,rb3           NB.  SEL is 1000 100 10 1
select. SEL
  case. 1000 do. set_polygon ''
  case. 100 do.  set_straight ''
  case. 10 do. set_geom ''
  fcase. do. set_bezier ''
end. 
)

hokusai_seltype_button=: 3 : 0
SEL=. ". rb0,rb1,rb2,rb3           NB.  SEL is 1000 100 10 1  // Poly<->Bezier
SELEK=. ". rb4,rb5                 NB.  SELEK is  10 1  //JP&ENG
select. SELEK                      NB. Japanese    
 case. 10 do.
  select. SEL
    case. 1000 do. set_polygon ''
    case. 100 do.  set_straight ''
    case. 10 do. set_geom ''
    fcase. do. set_bezier ''
  end. 
 case. 1 do.                     NB. English
  select. SEL
     case. 1000 do. set_e_polygon ''
     case. 100 do.  set_e_straight ''
     case. 10 do. set_e_geom ''
     fcase. do. set_e_bezier ''
  end. 
end.

)

NB. ----Japanese/Kanji-----------------------------------------------------
POLYSET=: '"01　井筒組の万字" "02　六つ手万字" "03　菱犀型" "04 万字つなぎ" "05　万字菱" "06　ひょうれつ麻の葉"'
POLYSET=: POLYSET, '"07　麻の葉つくし" "08　八つ手麻の葉"　"09　松川麻の葉" '

set_polygon=: 3 : 0
wd 'set komon ',POLYSET 
wd 'setselect komon 0'
)

STRAIGHTSET=: '"01　行きつ戻りつ" "02　釣り四つ目" '
STRAIGHTSET=: STRAIGHTSET,' "03　燭光の万字繋ぎ" "04　菱の万字繋ぎ" "05　破れ篭目" '
STRAIGHTSET=: STRAIGHTSET,'"06　松皮" "07　碁盤筋交い" "08　畳" "09　唐様障子のく" "10　NO79"'
STRAIGHTSET=:STRAIGHTSET,'"11　早割り碁盤割り手" "12　三重格子" "13　ねじのふた" "14　釣り稲妻" "15　菜籠麻の葉"'


set_straight=: 3 : 0
wd 'set komon ',STRAIGHTSET 
wd 'setselect komon 0'
)

GEOMSET=: '"01　輪違い麻の葉" "02　桜割り" "03　六角三つ割" "04　かくの七宝" "05　早割り"'
GEOMSET=: GEOMSET,' "06　金網亀甲" '

set_geom=: 3 : 0
wd 'set komon ',GEOMSET 
wd 'setselect komon 0'
)


BEZIERSET=: '"01 松並" "02　道化もっこう" "03　七宝のねじ" '
BEZIERSET=: BEZIERSET, '"04　蕨" "05　繋ぎ蕨" "06　四つで蕨" "07　流れ万字" "08　乱れ縦割り" "09　組入仕立脇"'
BEZIERSET=: BEZIERSET, '"10　尾の上重ね" "11　向い神通網" "12　阿蘭陀組" "13　捻り四つ手組" "14　うけ葵"'
BEZIERSET=: BEZIERSET, '"15　文の字繋ぎ" "16　菱割り(らの字）" "17　瓦小口" "18　碁盤割り"'
BEZIERSET=: BEZIERSET,' "19　 四つ手" "20　藤種型" "21　大井紋高麗型"'



set_bezier=: 3 : 0
wd 'set komon ',BEZIERSET 
wd 'setselect komon 0'
)

NB. -----English-----------------------------------------------------------------------------------------
POLYSETE=: '"01 Wellframe Gammadion" "02 6 summit Gammadion" "03 Diamond Rhino" "04 Connected Gammadion" "05 Diamond Gammadion"'
POLYSETE=: POLYSETE, ' "06 Line-up Hemp leaves" "07 Many Hemp leaves" "08 8 hand Hemp leaves"　"09 Pine Hemp leaves" '

set_e_polygon=: 3 : 0
wd 'set komon ',POLYSETE 
wd 'setselect komon 0'
)

STRAIGHTSETE=: '"01 Go and Back" "02 Suspending 4 Eyes" '
STRAIGHTSETE=: STRAIGHTSETE,' "03 Candle-power Gammadion" "04 Diamond Gammadion" "05 Broken basket" '
STRAIGHTSETE=: STRAIGHTSETE,'"06 Pine Cone" "07 Go board(0)" "08 Tatami/Mat" "09 Chinese sliding paper Door" "10 NO79"　'
STRAIGHTSETE=:STRAIGHTSETE,'"11 Go board(1)" "12 Triple Lattice" "13 Screw Top" "14 Suspended Lightning" "15 Basket for green"'

set_e_straight=: 3 : 0
wd 'set komon ',STRAIGHTSETE 
wd 'setselect komon 0'
)

GEOMSETE=: '"01 Conflict Helm leaves" "02 Cherry blossom" "03 Hexagonal" "04 Cloisonne"'
GEOMSETE=: GEOMSETE,'"05 quick patarn" "06 Turtle" '

set_e_geom=: 3 : 0
wd 'set komon ',GEOMSETE 
wd 'setselect komon 0'
)


BEZIERSETE=: '"01 Pine leaves" "02 Banksia roses" "03 Cloisonne" '
BEZIERSETE=: BEZIERSETE, '"04 Bracken(0)" "05 Bracken(1)" "06 Bracken(2)" "07 frown gammadian" "08 random lengthways" "09 buildin lengthways"'
BEZIERSETE=: BEZIERSETE, '"10 Many Tails" "11 Net" "12 Holland patarn" "13 twisted 4 hands " "14 Rose mallow"'
BEZIERSETE=: BEZIERSETE, '"15 Character 文" "16 Character ら" "17 Roof Tile" "18 Go board"'
BEZIERSETE=: BEZIERSETE,' "19 4 hands" "20 Wisteria seeds" "21 Korean Crest"'


set_e_bezier=: 3 : 0
wd 'set komon ',BEZIERSETE
wd 'setselect komon 0'
)

NB. =========================================
NB. ------(4)------set komontype_button------
hokusai_komontype_button=: 3 : 0
'SEL0 KOMON0'=: pick_komon_patarn ''        NB. type and patarn
CTABLE=. select_colortable SEL0             NB. PSGB-COLOR
CLINE0=. (<: KOMON0){CTABLE NB. select color line
CLINE=. order_set_color CLINE0              NB. remove null set(not infty) 
set_color  CLINE                             NB. set color table
)

pick_komon_patarn=: 3 : 0
NB. pol/st/bezier and nr. of band
SEL=. ". rb0,rb1,rb2,rb3
NB. rb is  100 10 1 0
KOMON=. ". 2{. komon NB. pick only number from (05 繋ぎ蕨)
SEL;KOMON
)

select_colortable=: 3 : 0
NB. take table
select. y    NB. Sel0    
  case. 1000 do. CTABLE=. PCOLOR 
  case. 100 do. CTABLE=. SCOLOR
  case. 10 do. CTABLE=. GCOLOR
  fcase. do. CTABLE=. BCOLOR
end.
)


order_set_color=: 3 : 0
NB. processing 0 0 0 or _ 
CLINE0 =.  (;{. y){. }. y    NB. drop top number   
if. 4 = # CLINE0 do. CLINE0=.  0 1 3 { CLINE0 end.
NUM=. # CLINE0
select. NUM 
 case. 3 do. CLINE=. ; CLINE0 
 fcase. do.  CLINE=. (;CLINE0) ,(3* 3-NUM) # _  
  NB. _ is number and fulfill nul 
end. 
)



set_color=: 3 : 0
NB. initial set
'a b c d e f g h i'=. y           NB. 0R<--->2B
wd'setfont Color0R ',font
wd'setfont Color0G ',font
wd'setfont Color0B ',font
wd'setfont Color1R ',font
wd'setfont Color1G ',font
wd'setfont Color1B ',font
wd'setfont Color2R ',font
wd'setfont Color2G ',font
wd'setfont Color2B ',font
NB. -------------------
wd'set Color0R *', ": a NB. put letter to edit
wd'set Color0G *', ": b
wd'set Color0B *', ": c
wd'set Color1R *', ": d
wd'set Color1G *', ": e
wd'set Color1B *', ": f
wd'set Color2R *', ": g
wd'set Color2G *', ": h
wd'set Color2B *', ": i
)


NB. -------color table------------------------------
NB. Hokusai's Woodplate is monocrome, so you may using anycolor!
NB. this color table is test color of Author
NB. You can change this table or on form color
NB. you overwrite this color table directly// don't change in edit-box 
NB. +++++++++++++++++++++++++++++++++++++++++++++
NB. Polygon max RGB table is 4th // 0 0 0 is 3rd
NB.  
P01=:3;246 191 0;244 213 0 ;92 84 36   
P02=:2;67 71 173; 67 90 160           
P03=:2;67 71 173; 67 90 160
P04=:2;67 71 173; 67 90 160                      NB. hokusai_mt 
P05=:2;0 164 116; 169 192 135                    NB.  hokusai_mc 
P06=:4;144 93 84; 230 75 107;0 0 0;144 93 84      NB. hokusai_ha 
P07=:3;144 93 84; 230 75 107;0 0 0                NB.  hokusai_at 
P08=:3;0 83 62  ;170 179 0;170 179 0               NB.  hokusai_ym  
P09=:4;169 192 135;151 166 30;0 0 0;104 126 82   NB.  hokusai_ma 
PCOLOR=: P01,P02,P03,P04,P05,P06,P07,P08,:P09    NB. compose polygon color
NB. --------------------------------
NB. straight line color table
S01=: 1;58 72 98                   NB. hokusai_iki 
S02=: 1;105 99 154                 NB.  hokusai_ty2 
S03=: 2;67 90 160; 0 123 195       NB.  hokusai_sm 
S04=: 2;43 75 101; 0 133 155       NB.  hokusai_hm 
S05=: 2;0 0 255;0 255 0            NB.  hokusai_yk 
S06=: 2;234 213 107;228 211 162    NB.  hokusai_mk2 
S07=: 1;137 172 215                NB.  hokusai_sk 
S08=: 2;0 0 255;164 255 164        NB.  hokusai_tt 
S09=: 1;0 0 255                    NB.  hokusai_ksy 
S10=: 1;109 150 156                NB.  hokusai_nex
S11=: 1;0 0 255                    NB.  hokusai_hg 
S12=: 1;0 0 255                    NB.  hokusai_tk 
S13=: 1;0 0 255                    NB.  hokusai_nf 
S14=: 1;0 0 255                    NB.  hokusai_ti 
S15=: 1;0 0 255                    NB.  hokusai_na 
SCOLOR=: S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,:S15
NB. -------------------------------------------
NB. geometric komon
G01=: 2;234 213 107;228 211 162       NB.  hokusai_wachigai2
G02=: 2;239 70 68; 227 199 0          NB.  hokusai_sw 
G03=: 2; 145 76 53; 105 60 52         NB.  hokusai_h3 
G04=: 2; 0 255 0 ;0 0 255             NB.  hokusai_ks  
G05=: 2; 234 213 107;228 211 162      NB.  hokusai_hy2 
G06=: 1; 0 0 255                      NB.  hokusai_kk1 
GCOLOR=: G01,G02,G03,G04,G05,:G06
NB. -------------------------------------------
NB. Bezier color table
B01=: 1; 0 181 110                NB.  hokusai_matsunami 10 15
B02=: 2;0 255 255 ;0 0 255        NB.  hokusai_douke 10 10
B03=: 2;0 181 110 ;0 0 255        NB.  hokusai_shippoun 15 15
B04=: 2;0 0 255 ; 0 255 0         NB.  hokusai_warabi 15 15
B05=: 1;0 255 255                 NB.  hokusai_tsunagi_warabi 10 10
B06=: 2;0 255 255 ;0 255 255      NB.  hokusai_yotsude_warabi 10 10
B07=: 2;0 130 173 ;0 156 209      NB.  hokusai_nmanji 10 10
B08=: 2;0 255 255 ;0 255 255      NB.  hokusai_mtate 10 10
B09=: 2;0 255 255 ;0 255 255      NB.  hokusai_kumiire 10 10
B10=: 2;0 110 123 ;61 142 149     NB.  hokusai_okasane 10 10 
B11=: 1;96 138 142                NB.  hokusai_jintuu 10 10
B12=: 2;0 255 255 ;0 255 255      NB.  hokusai_oranda0 10 10
B13=: 2;0 255 255 ;128 255 0      NB.  hokusai_yotsude_grad 10 10
B14=: 2;0 182 110 ;87 85 49       NB.  hokusai_aoi 10 10
B15=: 2;67 90 160;0 111 171       NB.  hokusai_bun 10 10
B16=: 2;83 54 56; 118 82 118      NB.  hokusai_ranoji_grad 10 10
B17=: 1;132 116 97                NB.  hokusai_kawara 10 10
B18=: 1;0 123 195                 NB.  hokusai_h63 10 10
B19=: 2;0 255 255 ;0 0 255        NB.  hokusai_y29 10 10 
B20=: 1; 32 69 55                 NB.  hokusai_fujitane 10 10
B21=: 1; 0 81 154                 NB. ooi  
BCOLOR=: B01,B02,B03,B04,B05,B06,B07,B08,B09,B10,B11,:B12
BCOLOR=: BCOLOR,B13,B14,B15,B16,B17,B18,B19,B20,:B21


NB. ==================================
NB. (5)--------- ok_button--->DRAW 
hokusai_ok_button=: 3 : 0
SIZE=: pick_size ''                    NB. using  y
'SEL0 KOMON'=: pick_komon_patarn ''    NB. select nr for komon_script 
COLOR=: order_color_table ''
COLOR  hokusai_draw SEL0;KOMON;SIZE
)


order_color_table=: 3 : 0
NB. u '' 
'SEL0 KOMON'=: pick_komon_patarn ''    NB. type and patarn
CTABLE=. select_colortable SEL0        NB. PSGB-COLOR
CLINE0=. (<: KOMON){CTABLE   NB. old color/RGB(include 0 0 0)
COLOR_NEW=.  pick_color_table ''    NB. new candidate 
COLOR=. COLOR_NEW order_draw_color CLINE0  NB. x new/ y old 
)

pick_color_table=: 3 : 0
NB. pickup pointed color
C0=.(". Color0R),(". Color0G),". Color0B
C1=.(". Color1R),(". Color1G),". Color1B
C2=.(". Color2R),(". Color2G),". Color2B
TMP=. C0;C1;C2
)


order_draw_color=: 4 : 0
NB. processing 0 0 0 or _ 
nr=: NR=. ;{. y    NB. numer of color // include No. info in top of line
COLOR_NEW=. x          
NB. clean //rebove _ box
  if. NR < # COLOR_NEW do. COLOR_NEW=. NR{. COLOR_NEW end. NB. remove _ box
  if. 4 = NR do. COLOR=.  (2{. COLOR_NEW),(<3#0),{: COLOR_NEW 
 NB. add Color3=black  
    else.  COLOR=.   COLOR_NEW   end.
)

NB.   ------pickup  order size--------------
pick_size=: 3 : '<. 1.3 1.6 *  2 # ". size ' NB.column make 1.3 times of raw 

hokusai_draw=: 4 : 0
'SEL0 KOMON SIZE'=: y   NB. type / fn-name
NB. 'COLOR0 COLOR1 COLOR2 SIZE' =. x 
COLOR=:  x
if. 1 = # COLOR do. COLOR =. ; COLOR end.
NB. polygon
if. 1000 = SEL0 do.  NB. poly 
  select. KOMON      NB. drop 
    case. 1 do. COLOR hokusai_im  SIZE NB. color3 fix
    case. 2 do. COLOR hokusai_mm  SIZE     
    case. 3 do. COLOR hokusai_s   SIZE     
    case. 4 do. COLOR hokusai_mt  SIZE     
    case. 5 do. COLOR hokusai_mc  SIZE     
    case. 6 do. COLOR hokusai_ha  SIZE     
    case. 7 do. COLOR hokusai_at  SIZE     
    case. 8 do. COLOR hokusai_ym  SIZE     
    case. 9 do. COLOR hokusai_ma  SIZE     
    end. 
end. 
NB. straight line
if. 100 = SEL0 do.  NB. straight
  select. KOMON     NB. drop 
    case. 1 do. COLOR hokusai_iki SIZE NB. color3 fix
    case. 2 do. COLOR hokusai_ty SIZE     
    case. 3 do. COLOR hokusai_sm2  SIZE NB. 2color     
    case. 4 do. COLOR hokusai_hm SIZE     
    case. 5 do. COLOR hokusai_yk SIZE 
    case. 6 do. COLOR hokusai_mk2 SIZE 
    case. 7 do. COLOR hokusai_sk  SIZE     
    case. 8 do. COLOR hokusai_tt  SIZE     
    case. 9 do. COLOR hokusai_ksy SIZE     
    case. 10 do. COLOR hokusai_nex SIZE     
    case. 11 do. COLOR hokusai_hg SIZE     
    case. 12 do. COLOR hokusai_tk SIZE     
    case. 13 do. COLOR hokusai_nf  SIZE     
    case. 14 do. COLOR hokusai_ti  SIZE     
    case. 15 do. COLOR hokusai_na  SIZE     
    end. 
end. 
if. 10 = SEL0 do.  NB. geom 
  select. KOMON      NB. drop 
    case. 1 do. COLOR hokusai_wachigai2 SIZE 
    case. 2 do. COLOR hokusai_sw  SIZE     
    case. 3 do. COLOR hokusai_h3  SIZE
    case. 4 do. COLOR hokusai_ks  SIZE     
    case. 5 do. COLOR hokusai_hy2  SIZE     
    case. 6 do. COLOR hokusai_kk1  SIZE     
  end.
end.
if. 1 = SEL0 do.  NB. bezier 
  select. KOMON   NB. drop 
    case. 1 do. COLOR hokusai_matsunami  SIZE     
    case. 2 do. COLOR hokusai_douke     SIZE     
    case. 3 do. COLOR hokusai_shippoun  SIZE
    case. 4 do. COLOR hokusai_warabi  SIZE     
    case. 5 do. COLOR hokusai_tsunagi_warabi SIZE     
    case. 6 do. COLOR hokusai_yotsude_warabi  SIZE     
    case. 7 do. COLOR hokusai_nmanji  SIZE      
    case. 8 do. COLOR hokusai_mtate  SIZE      
    case. 9 do. COLOR hokusai_kumiire SIZE     
    case. 10 do. COLOR hokusai_okasane  SIZE 
    case. 11 do. COLOR hokusai_jintuu  SIZE     
    case. 12 do. COLOR hokusai_oranda0  SIZE     
    case. 13 do. COLOR hokusai_hyotsude_grad  SIZE     
    case. 14 do. COLOR hokusai_aoi  SIZE     
    case. 15 do. COLOR hokusai_bun SIZE     
    case. 16 do. COLOR hokusai_ranoji_grad SIZE     
    case. 17 do. COLOR hokusai_kawara  SIZE     
    case. 18 do. COLOR hokusai_h63  SIZE     
    case. 19 do. COLOR hokusai_y29  SIZE     
    case. 20 do. COLOR hokusai_fujitane  SIZE     
    case. 21 do. COLOR hokusai_ooi  SIZE     
    end. 
end. 
)


hokusai_run ''
NB. EOF


