NB. ===========================
NB. require 'd:/language/j602-user/temp/graphics/hokusai/hokusai_tool.ijs'


NB. ------------------------------------------------
NB. 44-松並   //01
NB. Matsunami
MTNM0=: 3 1,3.1 12,8.9 12,:9 1
MTNM1=: 2 2.5,2.5 2.7,3 2,3.5 2.7,:4 2.5  NB. Hige left
MTNM0PARAM=: 3 1; 6 0;3 5 
NB. ----------------------------------

hokusai_matsunami=: 4 : 0
NB. 0 181 110 hokusai_matsunami 10 15
Color0=. x
Size=. y
tmp01=.  calculus_bezier4 MTNM0
tmp11=.  calculus_bezier3 MTNM1
NB. tmp21=. }:"1 (tmp11,.1) mp transm 4 0
NB. -------------------------------
tmp0=. Size calc_each_poly (< tmp01); <MTNM0PARAM
tmp1=. Size calc_each_poly (< tmp11);<MTNM0PARAM
(find_center tmp0) dwin ''
Color0 dline2 L:0 tmp0
Color0 dline2 L:0 tmp1
)

NB. --------------------------
NB. No.33 道化もっこう //02
NB. Bersier4 parameter  each 4 steps 
DM0=: 1 6,0.75 7.25,3.5 7.5,4 8,4.5 8,5 11.25,:6 11     NB. left upper quarter
DM0=: DM0,7 11.25,7.5 8,8 8,8.5 7.5,11.25 7.25 ,: 11 6  NB. right upper quarter
DM0=: DM0,11.25 4.75, 8.5 4.5,8 4,7.5 4,7 0.75,:6 1     NB. right down 
DM0=: DM0,5 0.75,4.5 4,4 4,3.5 4.5,0.75 4.75,: 1 6      NB. left down
NB. base x,y 1 6;9 0;5 4
DMPARAM=: 1 6;7.5 0;0 6.5

hokusai_douke=: 4 : 0
NB. Usage: (0 255 255 ; 0 0 255 ) hokusai_douke 10 10
'Color0 Color1'=. x
 Size=. y
tmp0=. calculus_bezier4 DM0
tmp0=.}:"1 (tmp0,.1) mp elongm 1 0.85        NB. elong 1 0.85
tmp1=. Size calc_each_poly  (<tmp0);<DMPARAM
tmp2=.}:"1 (tmp0,.1) mp transm 4 0           NB. trans 4 0 
tmp2=. Size calc_each_poly  (< tmp2);<DMPARAM
(find_center tmp1) dwin ''
Color0 dline2 L:0 tmp1
Color1 dline L:0 tmp2
)

NB. -------------------------
NB. No43 七宝のねじ //03
NB. screw of Shippou 
SPN0=: 1.5 8,3.5 12,6.5 7.5,7.5 10.5,6.5 6,3.5 10.5,: 1.5 8
NB. edge(half)
SPN0=: SPN0,4.5 6,0.5 4,3 2,0 4,3.5 6,: 1.5 8 
NB. center(4 wings)
SPN1=: 5 6,4.5 8  , 4 7  ,4.5 7.5  ,:5 6
SPN1=:SPN1,5.75 5  , 6 7 ,5.75 5.5  ,:5 6
SPN1=:SPN1,5.5 4, 6 5  , 5.5 4.5    ,:5 6
SPN1=:SPN1,4.5 6.7, 4 5  ,4.5 6    ,:5 6
NB. ---------------------------------------
NB.    center       top             center 
SPN2=: 5 6,4.5 8  , 4 7  ,4.5 7.5  ,:5 6
SPN2=: 4 7,4.5 8, (5 6), 5.75 5.5,:6 7
SPN3=:SPN2,5.75 5 , 6 7  ,5.75 5.5 ,:5 6
SPN4=:SPN3,5.5 4  , 6 5  ,5.5 4.5  ,:5 6
SPN5=:SPN4,4.5 6.7, 4 5  ,4.5 6    ,:5 6

SPN0PARAM=: 1.5 8;6 2.5;_1.5 6

hokusai_shippoun=: 4 : 0
NB. (0 181 110 ;0 0 255) hokusai_shippoun 15 15
'Color0 Color1 '=. x
Size=. y
tmp01=.  calculus_bezier4 SPN0
NB. tmp11=.}:"1 ((tmp01),.1) mp (rotm  1p1) mp transm 10.5 12.5
tmp12=.  calculus_bezier3 SPN1
NB. -------------------------------
tmp0=. Size calc_each_poly (< tmp01); <SPN0PARAM
tmp1=. Size calc_each_poly (< tmp12);<SPN0PARAM
(find_center tmp0) dwin ''
Color0 dline2 L:0 tmp0
Color1 dline L:0 tmp1
)



NB. --------------------------
NB. No35 蕨  //04
NB. warabi /Bracken
WARABI0=: 3 8.5,4 11,1.5 11,1.25 9,1 7,7 3,3 1,1 0,1 4.5,:3 3
WARAPARAM=: 3 8.5;5.5 _2;0.75 6.75

hokusai_warabi=: 4 : 0
NB.  (0 0 255 ; 0 255 0) hokusai_warabi 15 15
'Color0 Color1 '=. x
Size=. y
tmp01=.  calculus_bezier4 WARABI0
((Color0;Color1);<Size) draw_dline_grad (<tmp01),<WARAPARAM 
)


NB. -----------------------------
NB. N0. 40 繋ぎ蕨   //05
NB. Tsunagi Warabi
NB. Connected Brackens
NB. body of Warabi
WT0=:_1.5 6 ,_1 7 ,2.5 5, _5 1,: 0 0
WT1=:}:"1 (WT0,. 1) mp rotm 5r7p1  
WT2=:}:"1 (WT0,. 1) mp rotm _1r2p1 
NB.   plot_bezier_test0 (<WT0),WT1,WT2
WT3=: _1.5 5, _1 4.75 ,:_0.6 6
WT4=:}:"1 (WT3,. 1) mp rotm 5r7p1 
WT5=:}:"1 (WT3,. 1) mp rotm _1r2p1 

TWARABIPARAM=: 0 0 ;9 8 ;0 10


hokusai_tsunagi_warabi=: 4 : 0
NB. Usage: 0 255 255  hokusai_warabi 10 10
Color0 =. x
Size=. y
tmp01=. mat_bezier5&calc_bezier_all WT0
tmp02=. mat_bezier5&calc_bezier_all WT1
tmp03=. mat_bezier5&calc_bezier_all WT2
NB. -----------------------------------
tmp11=. calc_bezier3 WT3
tmp12=. calc_bezier3 WT4
tmp13=. calc_bezier3 WT5
NB. -------------------------------------
tmp1=. Size calc_each_poly  (<tmp01);<TWARABIPARAM
tmp2=. Size calc_each_poly  (<tmp02);<TWARABIPARAM
tmp3=. Size calc_each_poly  (<tmp03);<TWARABIPARAM
NB. --------------------------------------
tmp4=. Size calc_each_poly  (<tmp11);<TWARABIPARAM
tmp5=. Size calc_each_poly  (<tmp12);<TWARABIPARAM
tmp6=. Size calc_each_poly  (<tmp13);<TWARABIPARAM
NB. -------------------------
(find_center tmp2) dwin ''
Color0 dline3 L:0 tmp1
Color0 dline3 L:0 tmp2
Color0 dline3 L:0 tmp3
NB. ----------------------
Color0 dline2 L:0 tmp4
Color0 dline2 L:0 tmp5
Color0 dline2 L:0 tmp6
)

NB. -----------------------------
NB. N0.38 四つで蕨 //06
NB. 4 hands Brackens
NB. Warabi(1)
WR4_0=: 3 5.8, 3.2 4, 1.8 4 ,:2 6
WR4_0=: WR4_0,2.2 8,5 7  ,2.5 1  ,: 5.5 3                 NB. NW  
WR4_2=: }:"1 (WR4_0,. 1) mp (rotm 2r3p1) mp transm 10 _2  NB. SW  
WR4_1=: }:"1 (WR4_0,. 1) mp (rotm 1p1) mp transm 12 4     NB. SE
WR4_3=: }:"1 (WR4_0,. 1) mp (rotm _1r3p1) mp transm  2 6  NB. NE
WARABI40PARAM=: 0 0 ;12 0 ;0 16
NB. -------------------------------
NB. calc bezier
calc_yotsude_sub0=: 3 : 0
NB. u ''
tmp0=. 4 5 calc_bezier_mix WR4_0
tmp1=. 4 5 calc_bezier_mix WR4_2
tmp2=. 4 5 calc_bezier_mix WR4_1
tmp3=. 4 5 calc_bezier_mix WR4_3
(<tmp0),(<tmp1),(<tmp2),<tmp3
)

NB. --warabi(1)-----------------------------
WR4_10=: 7.5 13,7 12    ,8 12   ,:7.8 13.5
WR4_10=: WR4_10 ,7.5 16,5 15.5,9 8  ,:7 8
WR4_10=: }:"1 (WR4_10,. 1)  mp transm 5 4
WR4_12=: }:"1 (WR4_10,. 1) mp (rotm 1r2p1)mp (transm 26 _2)mp elongm 0.85 1
WR4_11=: }:"1 (WR4_10,. 1) mp (rotm 1p1)  mp transm 25 22  
WR4_13=: }:"1 (WR4_10,. 1) mp (rotm _1r2p1) mp (transm 3 23)mp elongm 0.85 1
NB. ---------------------------------
calc_yotsude_sub1=: 3 : 0
tmp0=: 4 5 calc_bezier_mix WR4_10
tmp1=: 4 5 calc_bezier_mix WR4_11
tmp2=: 4 5 calc_bezier_mix WR4_12
tmp3=: 4 5 calc_bezier_mix WR4_13
(<tmp0),(<tmp1),(<tmp2),<tmp3
)

NB. center flower minimize 65r100
calc_yotsude_sub2=: 3 : 0
tmp=. }:"1 (SPN1,.1) mp (transm 4.5 _3) mp elongm 0.65 0.65
calculus_bezier3 tmp 
)
NB. center circle -> minimize center flower 1r4
calc_yotsude_sub3=: 3 : 0
tmp=. }:"1 (SPN1,.1) mp (transm _3.5 37.5) mp elongm 0.25 0.25
calculus_bezier3 tmp 
)

NB. main---------------------------------
hokusai_yotsude_warabi=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_yotsude_warabi 10 10
'Color0 Color1 '=. x
Size=. y
'tmp0 tmp1 tmp2 tmp3'=. calc_yotsude_sub0 ''  NB. warabi-0
'tmp5 tmp6 tmp7 tmp8'=. calc_yotsude_sub1 ''  NB. warabi-1
tmp4=. calc_yotsude_sub2 ''
tmp9=. calc_yotsude_sub3 ''
NB. ----------------------------------------
tmp10=. Size calc_each_poly  (<tmp0);<WARABI40PARAM
tmp11=. Size calc_each_poly  (<tmp1);<WARABI40PARAM
tmp12=. Size calc_each_poly  (<tmp2);<WARABI40PARAM
tmp13=. Size calc_each_poly  (<tmp3);<WARABI40PARAM
NB. --------------------------------------
tmp15=. Size calc_each_poly  (<tmp5);<WARABI40PARAM
tmp16=. Size calc_each_poly  (<tmp6);<WARABI40PARAM
tmp17=. Size calc_each_poly  (<tmp7);<WARABI40PARAM
tmp18=. Size calc_each_poly  (<tmp8);<WARABI40PARAM
NB. ----------------------------------------------
tmp14=. Size calc_each_poly  (<tmp4);<WARABI40PARAM
tmp19=. Size calc_each_poly  (<tmp9);<WARABI40PARAM
NB. --------------------------------------
(find_center tmp11) dwin ''
Color0 dline2 L:0 tmp10  NB. Warabi(0)
Color0 dline2 L:0 tmp11
Color0 dline2 L:0 tmp12
Color0 dline2 L:0 tmp13
Color0 dline2 L:0 tmp14  NB. center flower
NB. ----------------------
Color1 dline2 L:0 tmp15  NB. Warabi(1)
Color1 dline2 L:0 tmp16
Color1 dline2 L:0 tmp17
Color1 dline2 L:0 tmp18
Color1 dline2 L:0 tmp19  NB. center circle
NB. -----------------------
)
NB.====================================
NB. 流れ万字 No.21  //07
NB. Streamed swastica

NMANJI0=: 2 7,  3.3  5.5  , 2  4 , 0.7 2.5 ,:2 1 NB. 5 points
NMANJI1=: 2 7 ,3.3 6, 3.3 5 ,: 2 4   
NMANJI1=: NMANJI1, 0.7 3,0.7 2 ,:2 1   NB. 4 point * 2  is  7points
NMANJI2=: 6 4,7.3 3,7.3 2 ,: 6 1
NMANJI3=: 2 4, 3.3 3,4.7 3 ,:   6 4
NMANJI4=: 2 1, 3.3 2,4.7 2 ,:  6 1
NMANJIPARAM=: 2 7;4 3;0 6


calc_nmanji_sub=: 3 : 0
tmp0=. calculus_bezier4 NMANJI1
tmp1=. calculus_bezier4 NMANJI2
tmp2=. calculus_bezier4 NMANJI3
tmp3=. calculus_bezier4 NMANJI4
(<tmp0),(<tmp1),(<tmp2),<tmp3
)

hokusai_nmanji=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_nmanji 10 10
'Color0 Color1'=. x
 Size=. y
'tmp0 tmp1 tmp2 tmp3'=. calc_nmanji_sub ''  
NB. ----------------------------------------
tmp10=. Size calc_each_poly  (<tmp0);<NMANJIPARAM
tmp11=. Size calc_each_poly  (<tmp1);<NMANJIPARAM
tmp12=. Size calc_each_poly  (<tmp2);<NMANJIPARAM
tmp13=. Size calc_each_poly  (<tmp3);<NMANJIPARAM
NB. --------------------------------------
(find_center tmp11) dwin ''
Color0 dline3 L:0 tmp10  NB. tate
Color0 dline3 L:0 tmp11
Color1 dline2 L:0 tmp12  NB. yoko
Color1 dline2 L:0 tmp13
)

NB. --------------------
NB. 早割りの図（乱れ縦割り） No. 23  //08
NB. Random cracking lengthways
MTATE0=: 3 11 ,8 9.3 ,8 7.7 ,: 3 6
MTATE0=: MTATE0,_2 4.3,_2 2.7 ,: 3 1
MTATE1=: 3 11 ,1 9.3,1 7.7 ,: 3 6
MTATE1=: MTATE1,5 4.3,5 2.7 ,: 3 1
MTATEPARAM=: 3 1;6 5;0 10

calc_mtate_sub=: 3 : 0
tmp0=. calculus_bezier4 MTATE0
tmp1=. calculus_bezier4 MTATE1
(<tmp0),(<tmp1)
)

hokusai_mtate=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_mtate 10 10
'Color0 Color1'=. x
 Size=. y
'tmp0 tmp1' =. calc_mtate_sub ''  
NB. ----------------------------------------
tmp10=. Size calc_each_poly  (<tmp0);<MTATEPARAM
tmp11=. Size calc_each_poly  (<tmp1);<MTATEPARAM
NB. --------------------------------------
(find_center tmp11) dwin ''
Color0 dline2 L:0 tmp10  NB. tate
Color1 dline2 L:0 tmp11
)
NB. ----------------------------
NB. 組み入れしたて脇 No27  //09
NB. suite No27
NB. tate neji
NB. KUMIIRE0=: 7 10,6 9,6 8,(7 7),8 6,8 5,(7 4),6 3,6 2,:(7 1)
NB. KUMIIRE0=:KUMIIRE0,8 2, 8 3,(7 4), 6 5, 6 6,(7 7), 8 8, 8 9,:(7 10) NB. neji0
KUMIIRE0=: (7 7),8 6,8 5,(7 4),6 3,6 2,:(7 1)
KUMIIRE0=:KUMIIRE0,8 2, 8 3,(7 4), 6 5, 6 6,:(7 7) NB. neji0
KUMIIRE1=: }:"1 (KUMIIRE0 ,.1) mp transm 2.7 0     NB. neji 1
NB. yoko 3 
KUMIIRE2=: (1 7),2 7.8 , 4 7.8 ,( 5 7) , 7 8.5 , 10 8.5 ,:(12 7)
KUMIIRE2=: KUMIIRE2, 10 5.5, 7 5.5,(5 7),4 6.2, 2 6.2,:(1 7) NB. yoko 0
KUMIIRE3=: }:"1 (KUMIIRE2 ,.1) mp transm 0 _3    NB. yoko 1
NB. KUMIIRE4=: }:"1 (KUMIIRE2 ,.1) mp transm 0 3     NB. yoko 2
NB. tate tokkuri
KUMIIRE5=:(3 10),3.5 9.5,3.5 7.5,(3 7),1.5 6,1.5 5,(3 4),3.5 3.5,3.5 1.5,:(3 1)
KUMIIRE5=: }:"1 (KUMIIRE5 ,.1) mp transm _0.6 0     NB. tokkuri left
KUMIIRE6=:(4 10),3.5 9.5,3.5 7.5,(4 7),5.5 6,5.5 5,(4 4),3.5 3.5,3.5 1.5,:(4 1)
NB. ---------------------------------------------------------------
KUMIIRE5=:(3 7),1.7 6,1.7 5,(3 4),3.5 3.5,3.5 1.5,:(3 1)
KUMIIRE5=: }:"1 (KUMIIRE5 ,.1) mp transm _0.9 0     NB. tokkuri left
KUMIIRE6=:(4 7),5.3 6,5.3 5,(4 4),3.5 3.5,3.5 1.5,:(4 1)

NB. -------------------------
KUMIIREPARAM=: 3 1;11 0;0 6
NB. ------------------------
calc_kumiire_sub0=: 3 : 0
tmp0=. calculus_bezier4  KUMIIRE0 
tmp1=. calculus_bezier4  KUMIIRE1 
(<tmp0),<tmp1
)

calc_kumiire_sub1=: 3 : 0
tmp2=. calculus_bezier4  KUMIIRE2 
tmp3=. calculus_bezier4  KUMIIRE3 
(<tmp2),(<tmp3)
)

calc_kumiire_sub2=: 3 : 0
tmp5=. calculus_bezier4  KUMIIRE5 
tmp6=. calculus_bezier4  KUMIIRE6 
(<tmp5),<tmp6
)

NB. ------------------------
hokusai_kumiire=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_kumiire 10 10
'Color0 Color1'=. x
 Size=. y
'tmp0 tmp1' =. calc_kumiire_sub0 ''  
'tmp2 tmp3' =. calc_kumiire_sub1 ''  
'tmp5 tmp6' =. calc_kumiire_sub2 ''  
NB. ----------------------------------------
tmp10=. Size calc_each_poly  (<tmp0);<KUMIIREPARAM
tmp11=. Size calc_each_poly  (<tmp1);<KUMIIREPARAM
NB. ----------------------------------------------
tmp12=. Size calc_each_poly  (<tmp2);<KUMIIREPARAM
tmp13=. Size calc_each_poly  (<tmp3);<KUMIIREPARAM
NB. tmp14=. Size calc_each_poly  (<tmp4);<KUMIIREPARAM
NB. -----------------------------------------
tmp15=. Size calc_each_poly  (<tmp5);<KUMIIREPARAM
tmp16=. Size calc_each_poly  (<tmp6);<KUMIIREPARAM
NB. --------------------------------------
(find_center tmp11) dwin ''
Color0 dline2 L:0 tmp10  NB. tate
Color1 dline2 L:0 tmp11
Color0 dline2 L:0 tmp12  NB. yoko 
Color1 dline2 L:0 tmp13
NB. Color1 dline2 L:0 tmp14
Color0 dline2 L:0 tmp15  NB. tate
Color1 dline2 L:0 tmp16
)

NB. --------------------------------
NB. 尾の上重ね No 39  //10
NB. 
OKASANE0=: 2 6,0.5  5,_0.5 4, 0.5 2  ,: 2 1
OKASANE0=: OKASANE0, 3.5 2,4.5 4,3.5  5   ,: 2 6
OKASANE1=: }:"1 (OKASANE0 ,.1) mp transm  0 2  NB. tokkuri left

calc_okasane_sub0=: 3 : 0
tmp0=. mat_bezier5&calculus_bezier_all OKASANE0
tmp1=. mat_bezier5&calculus_bezier_all OKASANE1
(<tmp0),<tmp1
)

OKASANE2=: }:"1 (OKASANE0 ,.1) mp (rotm 2r3p1) mp transm 6.9 5.1  NB. tokkuri left
OKASANE3=: }:"1 (OKASANE1 ,.1) mp (rotm 2r3p1) mp transm 6.9 5.1  NB. mp transm  0 1    NB. tokkuri left

calc_okasane_sub1=: 3 : 0
tmp2=. mat_bezier5&calculus_bezier_all OKASANE2
tmp3=. mat_bezier5&calculus_bezier_all OKASANE3
(<tmp2),<tmp3
)

OKASANE4=: }:"1 (OKASANE0 ,.1) mp (rotm _2r3p1) mp transm _0.9 9   NB. tokkuri left
OKASANE5=: }:"1 (OKASANE1 ,.1) mp (rotm _2r3p1) mp transm _0.9 9   NB. mp transm  0 1    NB. tokkuri left

calc_okasane_sub2=: 3 : 0
tmp4=. mat_bezier5&calculus_bezier_all OKASANE4
tmp5=. mat_bezier5&calculus_bezier_all OKASANE5
(<tmp4),<tmp5
)

NB. -------------------------
OKASANEPARAM=: 3 1;6.1 3.5;0 7


hokusai_okasane=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_okasane 10 10 
'Color0 Color1'=. x
 Size =. y
'tmp0 tmp1' =. calc_okasane_sub0 ''  
'tmp2 tmp3' =. calc_okasane_sub1 ''  
'tmp4 tmp5' =. calc_okasane_sub2 ''  
NB. ----------------------------------------
tmp10=. Size calc_each_poly  (<tmp0);<OKASANEPARAM
tmp11=. Size calc_each_poly  (<tmp1);<OKASANEPARAM
NB. ----------------------------------------------
tmp12=. Size calc_each_poly  (<tmp2);<OKASANEPARAM
tmp13=. Size calc_each_poly  (<tmp3);<OKASANEPARAM
NB. -----------------------------------------
tmp14=. Size calc_each_poly  (<tmp4);<OKASANEPARAM
tmp15=. Size calc_each_poly  (<tmp5);<OKASANEPARAM
NB. --------------------------------------
(find_center tmp11) dwin ''
Color0 dline2 L:0 tmp10  NB. tate
Color1 dline2 L:0 tmp11
Color0 dline2 L:0 tmp12  NB. yoko 
Color1 dline2 L:0 tmp13
Color0 dline2 L:0 tmp14  NB. tate
Color1 dline2 L:0 tmp15
)

NB.--------------------------------
NB. No55 向神通網  //11

JINTUU0=: (1 0.8), 4.3 0.8, 4.3 1.8, (2 4), 1 5,1 6.5 ,(3 7),4 7.1 ,: (5 7)                                 
NB.  4 4 3 4 4plot_bezier  JINTUU0 
NB. using mix type
JINTUU0=: JINTUU0,7 6.5,7 5 , (6 4), 3.7 2 ,3.7 0.8 ,:(7.5 0.8)  

JINTUUPARAM=: 1 1;6.5 0;0 5

hokusai_jintuu=: 4 : 0
NB. Usage: 0 255 255  hokusai_jintuu 10 10
Color0 =. x
 Size =. y
tmp0=. 4 4 3 4 4 calc_bezier_mix JINTUU0
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<JINTUUPARAM
NB. --------------------------------------
(find_center tmp10) dwin ''
Color0 dline3 L:0 tmp10  NB. tate
)

NB. -------------------------
NB.阿蘭陀組  NB. 81  //12
NB. Datch set
ORANDAK0=:(1 4),4.7 3.5 ,3 6 ,5.7 6.5,(6.5 5),6.6 3,:(6.5 1)
ORANDAK0=. ORANDAK0,5.7 _0.5,3 0,4.7 2.5,:(1 2)
ORANDAK1=: }:"1 (ORANDAK0 ,.1) mp (rotm 1p1) mp transm 2.3 6 NB. rot 180 degree
ORANDA0PARAM=: 2 1;6 0;0 7

calc_oranda0_sub=: 3 : 0
tmp0=. 5 3 5 calc_bezier_mix ORANDAK0
tmp1=. 5 3 5 calc_bezier_mix ORANDAK1
(<tmp0),<tmp1
)

hokusai_oranda0=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_oranda0 10 10
'Color0 Color1'=. x
 Size =. y
'tmp0 tmp1'=. calc_oranda0_sub ''
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<ORANDA0PARAM
tmp11=: Size calc_each_poly  (<tmp1);<ORANDA0PARAM
NB. --------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. tate
Color1 dline2 L:0 tmp11  NB. tate
)

NB. ----------------------------
NB. 53 捻りの四つ手組  //13
HYOTSUDE01=: (4 1), (4 3), (2 3)  ,:(2 5)
HYOTSUDE01=: HYOTSUDE01,(4 5), (4 7),:(6 7) 
HYOTSUDE01=: HYOTSUDE01,(6 5), (8 5),:(8 3) 
HYOTSUDE01=: HYOTSUDE01,(6 3), (6 1) ,:(4 1) 
HYOTSUDE1=: }:"1 (HYOTSUDE01 ,.1) mp rotm  1r3p1

HYOTSUDE02=: (4 0.6), (4 3), (1.3 3) ,:(1.5 5)
HYOTSUDE02=: HYOTSUDE02,(4 5), (4 7.7),:(6 7.6) 
HYOTSUDE02=: HYOTSUDE02,(6 5), (8.7 5),:(8.4 3) 
HYOTSUDE02=: HYOTSUDE02,(6 3), (6 0.3) ,:(4 0.6) 
NB. HYOTSUDE2=: }:"1 (HYOTSUDE02 ,.1) mp rotm  1r3p1


HYOTSUDE03=: (4 0.6),2.8 1.2 ,(4 3),3 3.5,(1.3 3), 2 4  ,:(1.5 5)
HYOTSUDE03=: HYOTSUDE03,2.5 6.2,(4 5),4.5 6 ,(4 7.7),5 7.4 ,:(6 7.6) 
HYOTSUDE03=: HYOTSUDE03,7.2 6.7,(6 5),7 4.5 ,(8.7 5),8 4,:(8.4 3) 
HYOTSUDE03=: HYOTSUDE03,7.5 2.5,(6 3),4.8 1.7,(6 0.3),5 1.2,:(4 0.6) 
HYOTSUDE3=: }:"1 (HYOTSUDE03 ,.1) mp rotm  1r3p1
HYOTSUDE3PARAM=: 4 0;5.2 _0.5;0.5 5.3


hokusai_hyotsude=: 4 : 0
NB. Usage: 0 255 255  hokusai_yotsude 10 10
Color0=. x
Size =. y
tmp0 =. calculus_bezier3 HYOTSUDE3
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<HYOTSUDE3PARAM
NB. --------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. tate
)

hokusai_hyotsude_grad=: 4 : 0
NB. Usage: 0 255 255 ;0 255 255 hokusai_yotsude_grad 10 10
'Color0 Color1'=. x
 Size =. y
tmp0 =. calculus_bezier3 HYOTSUDE3
((Color0;Color1);<Size) draw_dline_grad (<tmp0),<HYOTSUDE3PARAM 

)

NB. ---------------------------
NB. うけ葵　No37  //14
NB. a floating Rose mallow 
NB. flowers
AOI0=: (3.5 6.5), 4 8, 2.5 10,(1 8),_1 5 ,3.5 3 ,:(4 2)   
AOI0=:  AOI0, 4.5 3 , 9 5  ,(7 8), 5.5  10 , 4 8   ,:(4.5 6.5)
AOI1=: }:"1 (AOI0,.1) mp (rotm _1r3p1)  mp elongm 0.5 0.5
AOI2=: }:"1 (AOI0,.1) mp (rotm 1r3p1) mp (transm 20 _7)  mp elongm 0.5 0.5
NB. ----reverse flowers-------------------------------------------------
AOI1R=: }:"1 (AOI0,.1) mp (rotm _2r3p1) mp (transm 24 12.5)    mp elongm 0.5 0.5
AOI2R=: }:"1 (AOI0,.1) mp (rotm 2r3p1) mp (transm 44 5.5)  mp elongm 0.5 0.5

calc_aoi_sub0=: 3 : 0
tmp0 =. calculus_bezier4 AOI1
tmp1 =. calculus_bezier4 AOI2
(<tmp0),<tmp1
)

calc_aoi_sub2=: 3 : 0
tmp0R =. calculus_bezier4 AOI1R
tmp1R =. calculus_bezier4 AOI2R
(<tmp0R),<tmp1R
)

NB. -----------------------------------
AOIPARAM=: 0 0 ; 20 5;0 8

NB. -------stem------------------------
AOIK3=: (3.8 1.7),3.2 3,5   5 ,:(7.8 6.3)
AOIK4=: (8   1.7),8.6 3,6.8 5 ,:(4.9 6.3)
NB. --------------------------
AOIK5=: (4  6.2) , 3   5.5 , 4.5  4  ,:(6.25  3)
AOIK6=: (8.5 6.2), 9.5 5.5 , 8 4 ,(6.25  3),6.25 2.5,6.25 2.2 ,:(6.25 2)
NB. reverse not using rotate 
AOIK3R=: (18 1.2), 19.8 _0.5, 18.7  _1  ,:(15 _3.5)
AOIK4R=: (14.5 1.5),13.2 _0.5 ,14.3 _1,:(18 _3.5)
NB.-----------------------------------
AOIK5R=: (13.5 4.5) , 12  5 , 13.75  6.7 ,:(16.5  7.7)
AOIK6R=: (18.5 4.5), 20 5 , 18.75 6.7 ,(16.5  7.7),16.5 8.0,16.5 8.2 ,:(16.5 8.7)


calc_aoi_sub1=: 3 : 0
tmp2=. calculus_bezier4 AOIK3
tmp3=. calculus_bezier4 AOIK4
tmp4=. calculus_bezier4 AOIK5
tmp5=. calculus_bezier4 AOIK6
(<tmp2),(<tmp3),(<tmp4),<tmp5
)

calc_aoi_sub3=: 3 : 0
tmp2R=. calculus_bezier4 AOIK3R
tmp3R=. calculus_bezier4 AOIK4R
tmp4R=. calculus_bezier4 AOIK5R
tmp5R=. calculus_bezier4 AOIK6R
(<tmp2R),(<tmp3R),(<tmp4R),<tmp5R
)

 
hokusai_aoi=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_aoi 10 10
'Color0 Color1 '=. x
Size =. y
'tmp0 tmp1' =. calc_aoi_sub0 ''
'tmp0R tmp1R' =. calc_aoi_sub2 ''
'tmp2 tmp3 tmp4 tmp5' =. calc_aoi_sub1 ''
'tmp2R tmp3R tmp4R tmp5R' =. calc_aoi_sub3 ''
NB. ----------------------------------------
tmp10=. Size calc_each_poly  (<tmp0);<AOIPARAM
tmp11=. Size calc_each_poly  (<tmp1);<AOIPARAM
NB. ------------------------------------------
tmp10R=. Size calc_each_poly  (<tmp0R);<AOIPARAM
tmp11R=. Size calc_each_poly  (<tmp1R);<AOIPARAM
NB. ---------------------------------
tmp12=. Size calc_each_poly  (<tmp2);<AOIPARAM
tmp13=. Size calc_each_poly  (<tmp3);<AOIPARAM
tmp14=. Size calc_each_poly  (<tmp4);<AOIPARAM
tmp15=. Size calc_each_poly  (<tmp5);<AOIPARAM
NB. --------------------------------------
tmp12R=. Size calc_each_poly  (<tmp2R);<AOIPARAM
tmp13R=. Size calc_each_poly  (<tmp3R);<AOIPARAM
tmp14R=. Size calc_each_poly  (<tmp4R);<AOIPARAM
tmp15R=. Size calc_each_poly  (<tmp5R);<AOIPARAM
NB. ----------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. flower left
Color0 dline2 L:0 tmp11  NB. right
Color0 dline2 L:0 tmp10R  NB. flower left reverse
Color0 dline2 L:0 tmp11R  NB. right  reverse
NB. ----------------------------
Color1 dline2 L:0 tmp12  NB. stim1
Color1 dline2 L:0 tmp13  NB. stim1
Color1 dline2 L:0 tmp14  NB. stim2
Color1 dline2 L:0 tmp15  NB. stim2+
NB. ---------------------------
Color1 dline2 L:0 tmp12R  NB. stim1
Color1 dline2 L:0 tmp13R  NB. stim1
Color1 dline2 L:0 tmp14R  NB. stim1
Color1 dline2 L:0 tmp15R  NB. stim1
)
NB. -----------------------------------
NB. 文の字繋ぎ No.51  //15
NB. connected character 'bun'
NB. center is 3

BUN0=: (1.5 4.5),3 4.5 ,1.5 6 ,(3 7),4.5 6,3 4.5,: (4.5 4.5)
BUN1=: (1.5 5.5),3 5.5 ,1.5 4 ,(3 3), 4.5 4 ,3 5.5 ,:( 4.5 5.5)

calc_bun_sub0=: 3 : 0
tmp0 =. calculus_bezier4 BUN0
tmp1 =. calculus_bezier4 BUN1
(<tmp0),<tmp1
)
NB. center=3 base is 7/3
BUN2=: (1.5 7.7), 2.5 7.4  ,(3 8.2), 3.5 7.4 ,:(4.5 7.7)      NB. up(0)
BUN3=: (2.2 7.7),2.5 7 , ( 3 7),3.5 7  ,:(4 7.7) NB. up(1)
BUN4=: (1.5 2.3),2.5 2.6 , (3 1.8),3.5 2.6 ,:(4.5 2.3)       NB. down (3)
BUN5=: (2.2 2.3),2.5 3 ,(3 3), 3.5 3 ,:(4 2.3)   NB. down(2)

calc_bun_sub1=: 3 : 0
tmp2 =. calculus_bezier3 BUN2
tmp3 =. calculus_bezier3 BUN3
tmp4 =. calculus_bezier3 BUN4
tmp5 =. calculus_bezier3 BUN5
(<tmp2),(<tmp3),(<tmp4),<tmp5
)
BUN6=: (<3 8 ,: 3 8.5),.< 3 2 ,: 3 1.5 
NB. -------------------------

BUNPARAM=: 1.5 4.5; 4 4.5 ; 0 9

hokusai_bun=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_bun 10 10
'Color0 Color1'=. x
 Size =. y
'tmp0 tmp1' =. calc_bun_sub0 ''
'tmp2 tmp3 tmp4 tmp5' =. calc_bun_sub1 ''
'tmp6 tmp7'=: BUN6
NB. ----------------------------------------
tmp10=. Size calc_each_poly  (<tmp0);<BUNPARAM
tmp11=. Size calc_each_poly  (<tmp1);<BUNPARAM
NB. ----------------------------------------
tmp12=. Size calc_each_poly  (<tmp2);<BUNPARAM
tmp13=. Size calc_each_poly  (<tmp3);<BUNPARAM
tmp14=. Size calc_each_poly  (<tmp4);<BUNPARAM
tmp15=. Size calc_each_poly  (<tmp5);<BUNPARAM
NB. ------------------------------------------
tmp16=. Size calc_each_poly  (<tmp6);<BUNPARAM
tmp17=. Size calc_each_poly  (<tmp7);<BUNPARAM
NB. ----------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. flower left
Color1 dline2 L:0 tmp11  NB. right
Color0 dline2 L:0 tmp12  NB. flower left
Color1 dline2 L:0 tmp13  NB. right
Color0 dline2 L:0 tmp14  NB. flower left
Color1 dline2 L:0 tmp15  NB. right
NB.-------------------------------- 
Color0 dline2 L:0 tmp16  NB. flower left
Color1 dline2 L:0 tmp17  NB. right
)

NB. --------------------------
NB. 菱割り（らの字）N0. 59  //16
NB. diamond divide  
RANOJI0=: (1.5 9),3 8.8 , 1.8 8 ,(1.8 7),2.2 5.5,3 5 ,:(3.5 6.8) NB. 0/1/2
RANOJI0=: RANOJI0, 6 11,8 5.5 ,(4.2 4),1.5 3 ,4.5 7.5 ,:(4 2.8) NB. (2)/3/4/5
RANOJI0=: RANOJI0, 3.8 2.4 ,2.9  1.8 ,(3 1.5), 3.1 1.1 , 3.5 0.8,: (4 0.5)   NB. 6/7

RANOJIPARAM=: 9 2; 7 3; 0 8

hokusai_ranoji=: 4 : 0
NB. Usage: 0 255 255  hokusai_ranoji 10 10
Color0=. x
Size =. y
tmp0 =. calculus_bezier4 RANOJI0
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<RANOJIPARAM
NB. --------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. tate
)

hokusai_ranoji_grad=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255) hokusai_ranoji_grad 10 10
'Color0 Color1'=. x
 Size =. y
tmp0 =. calculus_bezier4 RANOJI0
((Color0;Color1);<Size) draw_dline_grad (<tmp0),<RANOJIPARAM 
)


NB. ---------------------------
NB. No. 77 瓦小口  //17
KAWARA0=:(5 7),5.5 9.7,8.5 9.7,:(9 7)  
KAWARA1=: (5 5),5.5 2.3,8.5 2.3 ,:(9 5)
KAWARA2=: (2.5 8.5),3 5.8,6 5.8 ,:(6.5 8.5)
KAWARA3=:(2.5 3.5 ),3 6.2,6 6.2,:(6.5 3.5)  

calc_kawara_sub0=: 3 : 0
tmp0 =. calculus_bezier4 KAWARA0
tmp1 =. calculus_bezier4 KAWARA1
tmp2 =. calculus_bezier4 KAWARA2
tmp3 =. calculus_bezier4 KAWARA3
(<tmp0),(<tmp1),(<tmp2),<tmp3
)
NB. -------------------------------
KAWARA4=: (6 2,:10 2);(3.5 1,:7.5 1);(6 0,:10 0)

KAWARAPARAM=: 5 7;5 0;0 10

hokusai_kawara=: 4 : 0
NB. Usage: 0 255 255 hokusai_kawara 10 10
Color0=. x
Size =. y
'tmp0 tmp1 tmp2 tmp3' =. calc_kawara_sub0 '' NB. flower
'tmp4 tmp5 tmp6 ' =. KAWARA4                 NB. line
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<KAWARAPARAM
tmp11=: Size calc_each_poly  (<tmp1);<KAWARAPARAM
tmp12=: Size calc_each_poly  (<tmp2);<KAWARAPARAM
tmp13=: Size calc_each_poly  (<tmp3);<KAWARAPARAM
NB. --------------------------------------
tmp14=: Size calc_each_poly  (<tmp4);<KAWARAPARAM
tmp15=: Size calc_each_poly  (<tmp5);<KAWARAPARAM
tmp16=: Size calc_each_poly  (<tmp6);<KAWARAPARAM
NB. --------------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. wave0
Color0 dline2 L:0 tmp11  NB. wave1
Color0 dline2 L:0 tmp12  NB. wave2
Color0 dline2 L:0 tmp13  NB. wave3
NB.------------------------------ 
Color0 dline2 L:0 tmp14  NB. line0
Color0 dline2 L:0 tmp15  NB. line1
Color0 dline2 L:0 tmp16  NB. line2
)

NB. -----------------------------------
NB. No. 63   //18
H63_line=: 2 3,2 5,4 5,4 6.5,8 6.5,8 5,:10 5
H63_flower=: (4.8 4.8),5.3 6,6.9 6,(7.2 4.8),8.5 4.3 ,8.5 3.5,:(7.2 3.2)
H63_flower=: H63_flower,6.9 2,5.3 2 ,(4.8 3.2),3.5 3.5 ,3.5 4.3 ,:(4.8 4.8)
H63PARAM=: 2 3;8 0;4 3.5

hokusai_h63=: 4 : 0
NB. Usage: 0 255 255  hokusai_h63 10 10
Color0=. x
Size =. y
tmp0  =. H63_line
tmp1 =. calculus_bezier4 H63_flower
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<H63PARAM
tmp11=: Size calc_each_poly  (<tmp1);<H63PARAM
NB. --------------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. wave0
Color0 dline2 L:0 tmp11  NB. wave1
)

NB. 四つ手 No29  //19
Y29_0=:(3 5),0.4 7,0.4 4,(3 6),2.3 7.5,4 8.5,(5 8),6.8 10.8,4.2 10.8,:(6 8) NB.0/1/2/3
Y29_0=:Y29_0,7 8.5,8.7 7.5 ,(8 6),9 5.4,9 5.6,:(8 5) NB. 4/5/6
Y29_0=:Y29_0,8.7 4.3,7 2.3,(6 4),5.4 2.8,5.6 2.8,(5 4),4 2.5, 2.3 3.7,:(3 5) NB. 7/8/9/0
NB. -------------------------------------
Y29_1=: (5 6),7 9 ,4 9 ,(6 6), 7.5 3 ,7.5 8,:(6 5)
Y29_1=: Y29_1,4 2,7 2 ,(5 5), 3.5 8, 3.5  3,:(5 6)

Y29_2=: }:"1 (Y29_1 ,.1) mp (elongm 0.6 0.6) mp transm  _1.5 _1.5
Y29_3=: }:"1 (Y29_1 ,.1) mp (rotm _13r45p1) mp (transm _1 _1) mp elongm 0.8 0.5 

calc_y29_sub1=: 3 : 0
tmp1=. calculus_bezier4 Y29_3  NB. inner flower
tmp2=. calculus_bezier4 Y29_2  NB. outer flower
(<tmp1),<tmp2
)

Y29PARAM=: 2 3;7.75 0;0 6.9


hokusai_y29=: 4 : 0
NB. Usage: (0 255 255 ;0 0 255) hokusai_y29 10 10 
'Color0  Color1'=. x
Size =. y
tmp0 =. calculus_bezier4 Y29_0
'tmp1 tmp2'=. calc_y29_sub1 ''
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<Y29PARAM
tmp11=: Size calc_each_poly  (<tmp1);<Y29PARAM
tmp12=: Size calc_each_poly  (<tmp2);<Y29PARAM
NB. --------------------------------------------
(find_center tmp10) dwin ''
Color1 dline2 L:0 tmp10  NB. circle
Color0 dline2 L:0 tmp11  NB. inner flower
Color0 dline2 L:0 tmp12  NB. outer flower
)
NB. -----------------------------------
NB. 藤種形 No.47  //20
NB. S0,S1 is bezier4 test
FUJIS1=: (4 3.2), 0 6,_1 3.8 ,:(3 2)  
FUJIS0=: (4 3.2), 0 5.5,_1 3 ,:(3 2)  
NB. ----------------------
FUJIS2=: (2 4),0.5 4.5,_0.5 3.5,:( 1 3)  
FUJIS4=: (10 4), 11.5 4.5,12 3.5,:(11 3)
NB. FUJIS3=: (6 2),7.5 1.5,6.5 0.5,:(4.4 1.2)
FUJIS3=: (3.6 1.6),5 1, 5.4 1.5,:(6 2)
FUJIS5=: (6 2),7 1.3,7  1,:(8.4 1.5) 

FUJIS=:FUJIS2;FUJIS3;FUJIS4;FUJIS5

FUJIL=: ( 6 2,:2 4);(1 3,:3.6 1.6 );(6 2,: 10 4);(11 3 ,: 8.4 1.5) NB. 4 lines
NB. -----------------------------
FUJISPARAM=: 2 6;11.3 0; 5.5 4

hokusai_fujitane=: 4 : 0
NB. Usage: 0 255 255  hokusai_fujitane 10 10
Color0=. x
Size =. y
'tmp0 tmp1 tmp2 tmp3'=. calc_bezier4 L:0 FUJIS2;FUJIS3;FUJIS4;FUJIS5
'tmp4 tmp5 tmp6 tmp7' =. FUJIL   NB. lines
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<FUJISPARAM
tmp11=: Size calc_each_poly  (<tmp1);<FUJISPARAM
tmp12=: Size calc_each_poly  (<tmp2);<FUJISPARAM
tmp13=: Size calc_each_poly  (<tmp3);<FUJISPARAM
NB. -------------------------------------------
tmp14=: Size calc_each_poly  (<tmp4);<FUJISPARAM
tmp15=: Size calc_each_poly  (<tmp5);<FUJISPARAM
tmp16=: Size calc_each_poly  (<tmp6);<FUJISPARAM
tmp17=: Size calc_each_poly  (<tmp7);<FUJISPARAM
NB. --------------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. 
Color0 dline2 L:0 tmp11  NB. 
Color0 dline2 L:0 tmp12  NB. 
Color0 dline2 L:0 tmp13  NB. 
NB. --------------------------
Color0 dline2 L:0 tmp14  NB. 
Color0 dline2 L:0 tmp15  NB. 
Color0 dline2 L:0 tmp16  NB. 
Color0 dline2 L:0 tmp17  NB. 
)

NB. ---------------------
NB. 大井紋高麗型 No48  //21
NB. OOi crest Korean type
OOI0=: (1.8 3.8),2.2 5.2,4 6.7 ,: (5 6)  NB.L-UP/upper
OOI1=: (1.8 4),3.5 3.2,4.5 4,: (5 6.2)   NB. Left upper/under
OOI4=: (6 0.8),6.5 2.5,8 3.5 ,: (9.2 3)  NB. right under/up
OOI5=: (5.8 1),7.2 0.3,8.7 1 ,: (9 3.2)  
NB. -------------------------------------
OOI2=: (6 6.2),6.5 4.2,7.5 3.2,: (9.2 4) NB. Right upper/under
OOI3=: (5.8 6),7.5 6.5 , 8.7 5.6,: (9 3.8) NB. Right upper/upper
OOI6=: (2 3.2),3 1,4.5 0.8 ,:(5.2 1)     NB.  R-under/under  
OOI7=: (1.8 3),3.5 4.2, 4.7 2.8 ,:(5 1)   NB. upper  

compose_OOI=: 3 : 'OOI0;OOI1;OOI2;OOI3;OOI4;OOI5;OOI6;OOI7'



NB. flower id use Y29_1
NB. flower center/upper/left
Y29_1=: (5 6),7 9 ,4 9 ,(6 6), 7.5 3 ,7.5 8,:(6 5)
Y29_1=: Y29_1,4 2,7 2 ,(5 5), 3.5 8, 3.5  3,:(5 6)

OOI8=: }:"1 (Y29_1 ,.1) mp (elongm 0.6 0.6) mp transm 2.4 0  
OOI9=: }:"1 (Y29_1 ,.1) mp (elongm 0.4 0.3) mp transm 3.4 5.2 
OOI10=: }:"1 (Y29_1 ,.1) mp (elongm 0.4 0.3) mp transm _1 2 

OOIPARAM=: 2 4; 9 0; 0 7

hokusai_ooi=: 4 : 0
NB. Usage: (0 255 255 ;0 255 255; 10 10) hokusai_yotsude_warabi ''
Color0=. x
Size =. y 
'tmp0 tmp1 tmp2 tmp3 tmp4 tmp5 tmp6 tmp7'=.calc_bezier4 L:0 compose_OOI ''
'tmp8 tmp9 tmp10x' =. calculus_bezier4 L:0 OOI8;OOI9;OOI10
NB. ----------------------------------------
tmp10=: Size calc_each_poly  (<tmp0);<OOIPARAM
tmp11=: Size calc_each_poly  (<tmp1);<OOIPARAM
tmp12=: Size calc_each_poly  (<tmp2);<OOIPARAM
tmp13=: Size calc_each_poly  (<tmp3);<OOIPARAM
tmp14=: Size calc_each_poly  (<tmp4);<OOIPARAM
tmp15=: Size calc_each_poly  (<tmp5);<OOIPARAM
tmp16=: Size calc_each_poly  (<tmp6);<OOIPARAM
tmp17=: Size calc_each_poly  (<tmp7);<OOIPARAM
NB. -----------------------------------------
tmp18=: Size calc_each_poly  (<tmp8);<OOIPARAM
tmp19=: Size calc_each_poly  (<tmp9);<OOIPARAM
tmp20=: Size calc_each_poly  (<tmp10x);<OOIPARAM
NB. --------------------------------------------
(find_center tmp10) dwin ''
Color0 dline2 L:0 tmp10  NB. 
Color0 dline2 L:0 tmp11  NB. 
Color0 dline2 L:0 tmp12  NB. 
Color0 dline2 L:0 tmp13  NB. 
Color0 dline2 L:0 tmp14  NB. 
Color0 dline2 L:0 tmp15  NB. 
Color0 dline2 L:0 tmp16  NB. 
Color0 dline2 L:0 tmp17  NB. 
NB. -------------------------
Color0 dline2 L:0 tmp18  NB. inner flower
Color0 dline2 L:0 tmp19  NB. upper flower
Color0 dline2 L:0 tmp20  NB. left flower
)


   